using System;
using System.Collections.Generic;
using System.Text;

namespace ReFrameworker
{
    static class Configuration
    {         
        //Location of external executables        
        public static string assemblerLocation;
        public static string disassemblerLocation;
        public static string nativeCompilerLocation;

        // File extensions
        public static string disassembledExtension;
        public static string tempExtension;

        //Directory names
        public static string RefsDir;
        public static string MethodsDir;
        public static string ClassesDir;
        public static string PayloadsDir;
        public static string ItemsDir;
        public static string InputDir;
        public static string DisassembledDir;
        public static string OutputDir;

        //Generated file names
        public static string deployFileName;
        public static string undeployFileName;

        //assembler options
        public static string AssembleOptions;
        public static string DisassembleOptions;

        //Language tokens
        public static string ret = "ret";
        public static string LabelPrefix = "IL_";
        public static int LabelLength = 7;        
        public static string AppendLabelSuffix = "_unique";

        //ReFrameworker defaults
        public static bool promptForDeployer = true;
        public static bool copyFromRuntime = true;
        public static bool defaultConsiderLineNumbering = false; //default
        public static int defaultDistance = 5;
        public static int defaultStackSize = 8;
        public static bool defaultBeforeLocation = false;
        public static string defaultInjectionMode = "PRE APPEND";

        //Current version
        public static string version = "V1.1";
    }
}
