using System;
using System.Collections.Generic;
using System.Text;

namespace ReFrameworker
{
    using System;
    using System.Diagnostics;
    using System.IO;

    internal static class FileUtilities
    {
        public static void Disassemble(string binaryName)
        {
            try
            {
                Process process = new Process();
                process.StartInfo.FileName = Configuration.disassemblerLocation;
                process.StartInfo.CreateNoWindow = true;
                process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                process.StartInfo.Arguments = Configuration.DisassembleOptions + " " + Configuration.InputDir + "\\" + binaryName + " /OUT=" + Configuration.DisassembledDir + "\\" + binaryName + Configuration.disassembledExtension;
                process.Start();
                process.WaitForExit();
                if (process.ExitCode != 0)
                    throw new Exception("Error while disassembling " + binaryName);
            }
            catch (Exception )
            {
                throw new Exception("Error while disassembling " + binaryName);
            }
        }

        public static void Assemble(string binaryName)
        {
            try
            {
                Process process = new Process();
                process.StartInfo.FileName = Configuration.assemblerLocation;
                process.StartInfo.CreateNoWindow = true;
                process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                process.StartInfo.Arguments = Configuration.AssembleOptions + " /OUTPUT=" + Configuration.OutputDir + "\\" + binaryName + " " + Configuration.DisassembledDir + "\\" + binaryName + Configuration.disassembledExtension;
                process.Start();
                process.WaitForExit();
                if (process.ExitCode != 0)
                    throw new Exception("Error while assembling " + binaryName);
            }
            catch (Exception)
            {
                throw new Exception("Error while assembling " + binaryName);
            }
        }

        public static void CopyFromRuntimeLocation(string binaryName, string binaryFullPath)
        {
            try
            {
                File.Copy(binaryFullPath, Configuration.InputDir + "\\" + binaryName, true);
            }
            catch (Exception )
            {
                throw new Exception("Error while copying  " + binaryName +" from the Runtime location");
            }
        }

        public static bool IsFileExists(string binaryFullPath)
        {
            return File.Exists(binaryFullPath);
        }

        public static void DeleteDirContent(string directory)
        {
            string[] files = Directory.GetFiles(directory);
            try
            {
                foreach (string s in files)
                {
                    File.Delete(s);
                }
                string[] dirs = Directory.GetDirectories(directory);
                foreach (string d in dirs)
                {
                    Directory.Delete(d, true);
                }
            }
            catch (Exception )
            {
                throw new Exception("Error while deleting directory content of " + directory);
            }
        }

        public static string RemoveBinaryExtension(string binaryName)
        {
            return binaryName.Remove(binaryName.Length - 4); 
        }


        public static void GenerateDeployer(string binaryName, string binaryLocation, string nativeImageLocation)
        {            
            try
            {
                StreamWriter writer = new StreamWriter(Configuration.deployFileName);
                writer.WriteLine("@echo off");
                writer.WriteLine("echo ReFrameworker Auto-Generated batch file for deploying modified binaries");
                writer.WriteLine("echo.");
                writer.WriteLine("echo Deploying " + binaryName + " to " + binaryLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("::YOU MIGHT WANT TO SET THE CORRECT PATH FROM WHICH THE MODIFIED BINARY IS COPIED");
                writer.WriteLine("copy /y " + Configuration.OutputDir + "\\" + binaryName + " " + binaryLocation + "\\" + binaryName);
                writer.WriteLine("echo Disabling NGEN for " + binaryName);
                writer.WriteLine("echo.");
                writer.WriteLine(Configuration.nativeCompilerLocation + " uninstall " + RemoveBinaryExtension(binaryName) +" 2 > NUL");
                writer.WriteLine("echo Deleting native image from " + nativeImageLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("rd /s /q " + nativeImageLocation + " 2>NUL");
                writer.Close();

                //generate undeployer
                writer = new StreamWriter(Configuration.undeployFileName);
                writer.WriteLine("@echo off");
                writer.WriteLine("echo ReFrameworker Auto-Generated batch file for undeploying (restoring) modified binaries");
                writer.WriteLine("echo.");
                writer.WriteLine("echo Undeploying " + binaryName + " from " + binaryLocation);
                writer.WriteLine("echo.");
                writer.WriteLine("::YOU MIGHT WANT TO SET THE CORRECT PATH FROM WHICH THE ORIGINAL BINARY IS COPIED");
                writer.WriteLine("copy /y " + Configuration.InputDir + "\\" + binaryName + " " + binaryLocation + "\\" + binaryName);
                writer.Close();
            }
            catch (Exception)
            {
                throw new Exception("Error while generating deployer batch files");
            }
        }
    }
}

