using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace ReFrameworker
{
    static class ParseConfigXML
    {
        public static void ParseFile(string XMLfile)
        {
            string Location = "";
            try
            {
                XmlTextReader objXmlTextReader = new XmlTextReader(XMLfile);
                string sName = "";
                while (objXmlTextReader.Read())
                {
                    switch (objXmlTextReader.NodeType)
                    {
                        case XmlNodeType.Element:
                            sName = objXmlTextReader.Name;
                            break;
                        case XmlNodeType.CDATA:
                            Location = objXmlTextReader.Value;
                            break;
                        case XmlNodeType.Text:
                            switch (sName)
                            {
                                case "assemblerLocation":
                                    Configuration.assemblerLocation = objXmlTextReader.Value;
                                    break;
                                case "disassemblerLocation":
                                    Configuration.disassemblerLocation = objXmlTextReader.Value;
                                    break;
                                case "nativeCompilerLocation":
                                    Configuration.nativeCompilerLocation = objXmlTextReader.Value;
                                    break;
                                case "disassembledExtension":
                                    Configuration.disassembledExtension = objXmlTextReader.Value;
                                    break;
                                case "tempExtension":
                                    Configuration.tempExtension = objXmlTextReader.Value;
                                    break;
                                case "RefsDir":
                                    Configuration.RefsDir = objXmlTextReader.Value;
                                    break;
                                case "MethodsDir":
                                    Configuration.MethodsDir = objXmlTextReader.Value;
                                    break;
                                case "ClassesDir":
                                    Configuration.ClassesDir = objXmlTextReader.Value;
                                    break;
                                case "PayloadsDir":
                                    Configuration.PayloadsDir = objXmlTextReader.Value;
                                    break;
                                case "ItemsDir":
                                    Configuration.ItemsDir = objXmlTextReader.Value;
                                    break;
                                case "InputDir":
                                    Configuration.InputDir = objXmlTextReader.Value;
                                    break;
                                case "DisassembledDir":
                                    Configuration.DisassembledDir = objXmlTextReader.Value;
                                    break;
                                case "OutputDir":
                                    Configuration.OutputDir = objXmlTextReader.Value;
                                    break;
                                case "deployFileName":
                                    Configuration.deployFileName = objXmlTextReader.Value;
                                    break;
                                case "undeployFileName":
                                    Configuration.undeployFileName = objXmlTextReader.Value;
                                    break;
                                case "AssembleOptions":
                                    Configuration.AssembleOptions = objXmlTextReader.Value;
                                    break;
                                case "DisassembleOptions":
                                    Configuration.DisassembleOptions = objXmlTextReader.Value;
                                    break;
                            }
                            break;
                        case XmlNodeType.EndElement:
                            break;
                    }
                }
            }
            catch (Exception)
            {
                throw new Exception("Error while parsing file " + XMLfile);

            }
        }
    }
}
